{Projekt 2      Autor: Jakub Novk 1F-51   login xnovak53

Program vykresl na obrazovce okno sloupcovho menu a uivatelsk okno,
kter pouv ke komunikaci s uivatelem. Program je vytvoen pomoc
programov jednotky CRT.}

program SLOUPCOVE_MENU;
uses Crt;
const
     MenuFile = 'proj_2.dat'; {jmno souboru s polokami menu}
     MaxMenus = 3;            {maximln poet nabdek}
     MaxLists = 5;
     MenuWin = 1;
     UserWin = 2;
     DfltWin = 3;
     MenuFileNotFound = 1;
     TooMuchMenus = 2;
type
    PMyItem = ^TMyItem;
    TMyItem = record
       Caption: string;
       NextItem: PMyItem;
    end;
    PMyMenu = ^TMyMenu;
    TMyMenu = record
       MenuName: string;
       ItemsCount: Byte;
       FirstItem: PMyItem;
       SelItem: Byte;
    end;
    TMyMenus = array[1..MaxMenus] of PMyMenu;
    PListItem = ^TListItem;
    TListItem = record
       PorCislo: integer;
       Prijmeni, Jmeno, Poznamka: string;
       NextItem: PListItem;
    end;
    TMyList = record
       ListName: string;
       FirstItem: PListItem;
       ActItem: PListItem;
    end;
    TMyLists = array[1..MaxLists] of ^TMyList;
var
   Finish: Boolean;
   Error: Byte;
   UsedKey: Char;
   OrigMode: Integer;
   MyMenus: TMyMenus;
   ActMenu: PMyMenu;
   MyLists: TMyLists;

procedure ErrorMessage(aError: Byte);
begin
    case aError of
       MenuFileNotFound:
          WriteLn('Soubor s polokami menu nebyl nalezen.');
       TooMuchMenus:
          begin
              Write('Poet nabdek v souboru s menu pesahuje maximln');
              WriteLn('definovanou hodnotu.');
          end;
    end;
end;
procedure WriteCenter(aStr: string);
   {vype pedan etzec doprosted aktuln obrazovky, pokud se tam vejde}
var
   WinWidth, aX: Byte;
begin
    WinWidth := Lo(WindMax) - Lo(WindMin);
    if Length(aStr) < WinWidth then
    begin
        aX := ((WinWidth - Length(aStr)) div 2) + 1;
        GotoXY(aX, WhereY);
        WriteLn(aStr);
        GotoXY(1, WhereY);
    end;
end;

procedure StatusBar(aStr: string); {vykresl stavov dek s hlenm}
var
   OrigAttr: Word;
begin
    OrigAttr := TextAttr;
    Window(1, 25, 80, 25);
    TextBackground(LightGray);
    TextColor(Black);
    Write(aStr);
    ClrEol;
    TextAttr := OrigAttr;
end;

procedure Activate(aWinName: Byte);
   {podle pedefinovanch konstant aktivuje (vykresl) pslun okno}
var
   i: Byte;
begin
    case aWinName of
      MenuWin:
         begin
           Window(1, 3, 20, 25);
           TextBackground(Black);
           ClrScr;
           TextColor(DarkGray);
           Write('');
           for i := 2 to 19 do
               Write('');
           Write('');
           for i := 2 to 21 do
           begin
               Write('');
               GotoXY(20, i);
               Write('');
           end;
           Write('');
           for i := 2 to 19 do
               Write('');
           Write('');
           StatusBar(
              ' Pouijte klvesy "Up" a "Down" pro pohyb v menu, "Enter" pro vbr.');
           Window(3, 4, 18, 23);
           TextColor(Yellow);
         end;
      UserWin:
         begin
           Window(21, 3, 80, 25);
           TextBackground(Blue);
           ClrScr;
           TextColor(LightCyan);
           Write('');
           for i := 2 to 59 do
               Write('');
           Write('');
           for i := 2 to 21 do
           begin
               Write('');
               GotoXY(60, i);
               Write('');
           end;
           Write('');
           for i := 2 to 59 do
               Write('');
           Write('');
           StatusBar(
              ' Pouijte klvesy "Up" a "Down" pro pohyb v menu, "Enter" pro vbr.');
           Window(24, 5, 77, 22);
           TextColor(White);
         end;
      DfltWin:
         begin
             Window(1, 1, 80, 25);
             TextBackground(Black);
             TextColor(White);
             ClrScr;
         end;
    end;
end;

procedure SelectRow(aCaption: string; RowNum: Byte);
   {zvrazn pslun dek v menu}
begin
    TextBackground(LightGreen);
    TextColor(Yellow);
    GotoXY(1, RowNum);
    Write(aCaption);
    ClrEol;
end;

procedure DrawMyMenu(var aMyMenu: TMyMenu; aSelItem: Byte);
   {vype poloky menu a zvrazn vybran dek}
var
   i: Byte;
   TempStr: string;
   TempItem: PMyItem;
begin
    aMyMenu.SelItem := aSelItem;
    if aMyMenu.SelItem = 0 then
       aMyMenu.SelItem := aMyMenu.ItemsCount;
    if aMyMenu.SelItem > aMyMenu.ItemsCount then
       aMyMenu.SelItem := 1;
       {pedchoz dv podmnky zajiuj cyklick prochzen nabdek,
       tj. pesunut kurzoru v menu zezdola nahoru a naopak}
    Activate(MenuWin);
    TempItem := aMyMenu.FirstItem;
    for i := 1 to aMyMenu.ItemsCount do
    begin
        if i = aMyMenu.SelItem then TempStr := TempItem^.Caption;
        WriteLn(TempItem^.Caption);
        TempItem := TempItem^.NextItem;
    end;
    SelectRow(TempStr, aMyMenu.SelItem)
end;

procedure ReadMenus(var aMenus: TMyMenus; var aError: Byte);
   {nate ze souboru poloky jednotlivch nabdek a vytvo z nich linern
   seznam}
var
   i, j: Byte;
   TempStr: string;
   TempItem1, TempItem2: PMyItem;
   F: text;
begin
    Assign(F, MenuFile);
    {$I-}
    Reset(F);
    {$I+}
    if IOResult = 0 then
    begin
         i := 1;
         ReadLn(F, TempStr);
         while not eof(F) and (i <= MaxMenus) do
         begin
             New(aMenus[i]);
             aMenus[i]^.MenuName := TempStr;
             ReadLn(F, TempStr);
             New(TempItem1);
             TempItem1^.Caption := TempStr;
             TempItem1^.NextItem := nil;
             aMenus[i]^.FirstItem := TempItem1;
             j := 1;
             ReadLn(F, TempStr);
             while Pos('[', TempStr) = 0 do
             begin
                 New(TempItem2);
                 TempItem2^.Caption := TempStr;
                 TempItem2^.NextItem := nil;
                 TempItem1^.NextItem := TempItem2;
                 TempItem1 := TempItem2;
                 j := j + 1;
                 if eof(F) then
                    TempStr := '['
                 else
                    ReadLn(F, TempStr);
             end;
             aMenus[i]^.ItemsCount := j;
             aMenus[i]^.SelItem := 1;
             i := i + 1;
         end;
         if (i > MaxMenus) and not eof(F) then
               {poet nabdek menu peshl maximln definovanou hodnotu}
            aError := TooMuchMenus;
         Close(F);
    end
    else
        aError := MenuFileNotFound; {soubor s polokami menu nebyl nalezen}
end;

procedure DisposeMenus(aMenus: TMyMenus);
   {uvolnn seznamu s nabdkami menu z pamti}
var
   i: Byte;
   TempItem: PMyItem;
begin
    for i := 1 to MaxMenus do
    begin
        if aMenus[i] <> nil then
        begin
            while aMenus[i]^.FirstItem^.NextItem <> nil do
            begin
                TempItem := aMenus[i]^.FirstItem;
                aMenus[i]^.FirstItem := TempItem^.NextItem;
                Dispose(TempItem);
            end;
            Dispose(aMenus[i]^.FirstItem);
            Dispose(aMenus[i]);
        end;
    end;
end;

procedure ProcessMenu1(var aMenu: PMyMenu);
   {oetuje vbr pkazu z prvnho menu}
begin
    case aMenu^.SelItem of
       1: begin
              DrawMyMenu(MyMenus[2]^, 1);
              Activate(UserWin);
              aMenu := MyMenus[2];
          end;
       2: begin
              DrawMyMenu(MyMenus[3]^, 1);
              Activate(UserWin);
              aMenu := MyMenus[3];
          end;
       3: begin
              WriteLn('Npovda k programu se seznamy - nedokoneno');
          end;
    end;
end;

procedure ProcessMenu2(var aMenu: PMyMenu);
{oetuje vbr pkazu z druhho menu}
begin
    case aMenu^.SelItem of
       1: begin
              WriteLn('Vytvoit nov seznam');
          end;
       2: begin
              WriteLn('Otevt existujc seznam');
          end;
       3: begin
              WriteLn('Uloit seznam');
          end;
       4: begin
              WriteLn('Zavt seznam');
          end;
       5: begin
              WriteLn('Porovnat dva seznamy');
          end;
       6: begin
              WriteLn('Slouit dva seznamy do jednoho');
          end;
       7: begin
              DrawMyMenu(MyMenus[1]^, MyMenus[1]^.SelItem);
              Activate(UserWin);
              aMenu := MyMenus[1];
          end;
    end;
end;

procedure ProcessMenu3(var aMenu: PMyMenu);
{oetuje vbr pkazu z tetho menu}
begin
    case aMenu^.SelItem of
       1: begin
              WriteLn('Prochzet seznam po prvcch');
          end;
       2: begin
              WriteLn('Pidat nov prvek seznamu za aktuln prvek');
          end;
       3: begin
              WriteLn('Vloit nov prvek seznamu ped aktuln prvek');
          end;
       4: begin
              WriteLn('Zruit aktuln prvek');
          end;
       5: begin
              WriteLn('Hledat prvek v seznamu');
          end;
       6: begin
              DrawMyMenu(MyMenus[1]^, MyMenus[1]^.SelItem);
              Activate(UserWin);
              aMenu := MyMenus[1];
          end;
    end;
end;

function GetItemCaption(aProcMenu: TMyMenu): string;
   {zjist Titulek vybranho pkazu - poloky menu}
var
   i: Byte;
   TempItem: PMyItem;
begin
    TempItem := aProcMenu.FirstItem;
    for i := 1 to aProcMenu.SelItem - 1 do
        TempItem := TempItem^.NextItem;
    GetItemCaption := TempItem^.Caption;
end;

function ProcessKey(aKey: Char; var aActMenu: PMyMenu): Boolean;
   {zpracovv stisk klvesy podle ordinln hodnoty pijatho znaku,
   vrac Booleovskou hodnotu, zda m program pokraovat nebo skonit}
begin
    case aKey of
      #13: {Enter}
      begin
          if GetItemCaption(aActMenu^) = 'Konec' then
                {z menu byla vybrna poloka "Konec", program tedy kon}
             ProcessKey := True
          else
          begin
             if aActMenu^.MenuName = '[hlavni]' then
                ProcessMenu1(aActMenu)
             else if aActMenu^.MenuName = '[seznam]'then
                     ProcessMenu2(aActMenu)
                  else if aActMenu^.MenuName = '[editace]' then
                          ProcessMenu3(aActMenu);
             ProcessKey := False;
          end;
      end;
      #72: {ipka nahoru}
      begin
          DrawMyMenu(aActMenu^, aActMenu^.SelItem - 1);
             {pekresl menu s tm, e vybrna bude pedchzejc poloka}
          Activate(UserWin);
          ProcessKey := False;
      end;
      #80: {ipka dol}
      begin
          DrawMyMenu(aActMenu^, aActMenu^.SelItem + 1);
             {pekresl menu s tm, e vybrna bude nsledujc poloka}
          Activate(UserWin);
          ProcessKey := False;
      end;
    end;
end;

begin
     OrigMode := LastMode;
     TextBackground(LightGray);
     ClrScr;
     TextColor(Red);
     WriteCenter('ALGORITMY A PROGRAMOVN - Projekt2: Sloupcov menu.');
     TextColor(Black);
     WriteCenter('Autor: Jakub NOVK 1F-51 1999/2000');
     Error := 0;
     ReadMenus(MyMenus, Error);
     if Error = 0 then {spn se naetly poloky menu}
     begin
         DrawMyMenu(MyMenus[1]^, MyMenus[1]^.SelItem);
         ActMenu := MyMenus[1];
         Activate(UserWin);
         Finish := False;
         repeat
             UsedKey := ReadKey;
             if UsedKey = #0 then UsedKey := ReadKey;
                {speciln klvesy generuj dva znaky, z nich prvn je
                znak s ordinlnm znakem 0 a druh charakterizuje klvesu}
             Finish := ProcessKey(UsedKey, ActMenu);
         until Finish;
         DisposeMenus(MyMenus);
         Activate(DfltWin);
         {TextMode(OrigMode);}
     end
     else
         ErrorMessage(Error);
end.