{Projekt 3      Autor: Jakub Novk 1F-51   login xnovak53

Programov jednotka pro konen automat.
vznam zkratek:
       B        body - tlo
       Dg       digit - slice
       F        finish - konec
       Fm       firm - firma
       Ffth     fifth - pt
       Fst      first - prvn
       FstNm    first name - kestn jmno
       Fth      fourth - tvrt
       LstNm    last name - pjmen
       Lt       letter - psmeno
       NatNum   native number - rodn slo
       No       is missing - chyb
       Nt       note - poznmka
       PChar    printable character - tisknuteln znak
       S        start - zatek
       Sb       seems to be - vypad to, e bude
       Sep      separator - oddlova
       Snd      second - druh
       SndNm    second name - druh jmno
       Trd      third - tet
       W        waiting - oekvan
       Wr       wrong - patn
}

Unit Proj_3u;

interface

const
     DefaultInFile = 'Proj_3.dat';
     DefaultOutFile = 'Proj_3.rec';
     DefaultProtocolFile = 'Proj_3.txt';
     PartsCount = 6; {poet st, na kter se dl vstupn dek}
type
    TState = ({vnitn stavy: } Start, SFstNm, BFstNm, FFstNm, FstItem,
             SSndNm, BSndNm, FSndNm, SbNoSndNm, WSep1, SndItem, SLstNm,
             BLstNm, FLstNm, TrdItem, Dg1, Dg2, Dg3, Dg4, Dg5, Dg6, Slash,
             Dg7, Dg8, Dg9, Dg10, SbFNatNum, FthItem, SFm, BFm, SbFFm,
             WSep2, FfthItem, SNt, BNt, SbFNt,
             {konen stavy: } EmptyLn, NoQMark, UnComplete, NoSep, WrFstNm,
             WrSndNm, WrLstNm, WrNatNum, WrLstDg, WrFmNt, AllRight);
    TSettings = record
        InFile, OutFile, Protocol: string;
        MadeSettings: Boolean;
    end;
    TItem = array[1..PartsCount] of string;

procedure SetSettings(var Settings: TSettings);
   {nastav parametry vkonu programu konen automat}
procedure Launch(var Settings: TSettings);
   {provede konen automat s pedanmi parametry}

implementation

uses Crt, Proj_3ua {obsahuje procedury pro prci v uivatelskm prosted};

const
    EndState = [EmptyLn..AllRight]; {interval konench stav}
    Lt = ['a'..'z', '', '', '', '', '', '', '', '', '', '', '',
           '', '', '', '', 'A'..'Z', '', '', '', '', '', '', '',
           '', '', '', '', '', '', '', '']; {uznvan znaky jmen}
    Dg = ['0'..'9']; {slice}
    PChr = [#32..#255] - ['"']; {tisknuteln znaky krom uvozovek, kter
                                se pouvaj jako dc znak}

procedure SetSettings(var Settings: TSettings);
   {nastav parametry vkonu programu konen automat}
var
   Key: Char;
begin
     ShowCursor;
     WriteLn('Chcete pout implicitn nastaven? (a/n) ');
     Key := ReadKey;
     if Key in ['a', 'A'] then
     begin
         Settings.InFile := DefaultInFile;
         Settings.OutFile := DefaultOutFile;
         Settings.Protocol := DefaultProtocolFile;
         WriteLn;
         WriteLn('Bylo pouito implicitn nastaven.');
         WriteLn;
         WriteLn('   Jmno vstupnho souboru:    ', DefaultInFile);
         WriteLn('   Jmno vstupnho souboru:   ', DefaultOutFile);
         WriteLn('   Jmno souboru s protokolem: ', DefaultProtocolFile);
     end
     else {jinak uivatel zad jmna soubor, kter chce pout}
     begin
         WriteLn;
         Write('   Jmno vstupnho souboru:    ');
         ReadLn(Settings.InFile);
         Write('   Jmno vstupnho souboru:   ');
         ReadLn(Settings.OutFile);
         Write('   Jmno souboru s protokolem: ');
         ReadLn(Settings.Protocol);
     end;
     Settings.MadeSettings := True;
     WriteLn;
     HideCursor;
end;

function WriteState(aState: TState): string;
   {podle dosaenho konenho stavu navrt etzec s hlenm}
begin
    case aState of
         EmptyLn:    WriteState := 'Przdn dek';
         NoQMark:    WriteState := 'Chyb uvozovky';
         UnComplete: WriteState := 'Nepln dek';
         NoSep:      WriteState := 'Chyb oddlova poloek na dku';
         WrFstNm:    WriteState := 'Chyba v kestnm jmnu';
         WrSndNm:    WriteState := 'Chyba ve druhm jmnu';
         WrLstNm:    WriteState := 'Chyba v pjmen';
         WrNatNum:   WriteState := 'Chyba v rodnm sle';
         WrLstDg:    WriteState := 'Neplatn posledn slice r..';
         WrFmNt:     WriteState := 'Chyba v nzvu firmy nebo v poznmce';
         AllRight:   WriteState := 'V podku';
    end;
end;

procedure InterpretChar(var aInLn: string; var j: Integer;
                        var aState: TState; var aItem: TItem);
   {struktura "case" charakterizujc vlastn konen automat,
   vyhodnocuje (interpret) znak, podle stavu, ve kterm se prv nachz}
var
   TempState: TState;
begin
  if j > Length(aInLn) then {ji bylo dosaeno konce dku}
  begin
      if aState in [FfthItem, SbFNt] then {konce dku sm bt dosaeno pouze
                                           v tchto dvou stavech}
          aState := AllRight
      else                                 {jinak je dek nepln}
          if aState = Start then aState := EmptyLn
          else aState := UnComplete;
  end
  else {jinak pichz korektn znak a je dle posuzovn}
  begin
      case aState of
        Start:     begin
                       if aInLn[j] = '"' then TempState := SFstNm;
                       if aInLn[j] = ' ' then TempState := Start;
                       if not (aInLn[j] in ['"', ' ']) then
                          TempState := NoQMark;
                   end;
        SFstNm:    begin
                       if aInLn[j] in Lt then
                       begin
                           TempState := BFstNm;
                           aItem[1] := aItem[1] + aInLn[j];
                       end
                       else TempState := WrFstNm;
                   end;
        BFstNm:    begin
                       if aInLn[j] in Lt then
                       begin
                           TempState := BFstNm;
                           aItem[1] := aItem[1] + aInLn[j];
                       end;
                       if aInLn[j] = '"' then TempState := FFstNm;
                       if not (aInLn[j] in (['"'] + Lt)) then
                          TempState := WrFstNm;
                   end;
        FFstNm:    begin
                       if aInLn[j] = ',' then TempState := FstItem;
                       if aInLn[j] = ' ' then TempState := FFstNm;
                       if not (aInLn[j] in [',', ' ']) then
                          TempState := NoSep;
                   end;
        FstItem:   begin
                       if aInLn[j] = '"' then TempState := SSndNm;
                       if aInLn[j] = ' ' then TempState := FstItem;
                       if not (aInLn[j] in ['"', ' ']) then
                          TempState := NoQMark;
                   end;
        SSndNm:    begin
                       if aInLn[j] in Lt then
                       begin
                           TempState := BSndNm;
                           aItem[2] := aItem[2] + aInLn[j];
                       end;
                       if aInLn[j] = '"' then TempState := SbNoSndNm;
                       if not (aInLn[j] in (['"'] + Lt)) then
                          TempState := WrSndNm;
                   end;
        BSndNm:    begin
                       if aInLn[j] in Lt then
                       begin
                           TempState := BSndNm;
                           aItem[2] := aItem[2] + aInLn[j];
                       end;
                       if aInLn[j] = '"' then TempState := FSndNm;
                       if not (aInLn[j] in (['"'] + Lt)) then
                          TempState := WrSndNm;
                   end;
        FSndNm:    begin
                       if aInLn[j] = ',' then TempState := SndItem;
                       if aInLn[j] = ' ' then TempState := FSndNm;
                       if not (aInLn[j] in [',', ' ']) then
                          TempState := NoSep;
                   end;
        SbNoSndNm: begin
                       if aInLn[j] = ',' then TempState := SndItem;
                       if aInLn[j] = ' ' then TempState := WSep1;
                       if not (aInLn[j] in [',', ' ']) then
                          TempState := NoSep;
                   end;
        WSep1:      begin
                       if aInLn[j] = ',' then TempState := SndItem;
                       if aInLn[j] = ' ' then TempState := WSep1;
                       if not (aInLn[j] in [',', ' ']) then
                          TempState := NoSep;
                   end;
        SndItem:   begin
                       if aInLn[j] = '"' then TempState := SLstNm;
                       if aInLn[j] = ' ' then TempState := SndItem;
                       if not (aInLn[j] in ['"', ' ']) then
                          TempState := NoQMark;
                   end;
        SLstNm:    begin
                       if aInLn[j] in Lt then
                       begin
                           TempState := BLstNm;
                           aItem[3] := aItem[3] + aInLn[j];
                       end
                       else TempState := WrLstNm;
                   end;
        BLstNm:    begin
                       if aInLn[j] in Lt then
                       begin
                           TempState := BLstNm;
                           aItem[3] := aItem[3] + aInLn[j];
                       end;
                       if aInLn[j] = '"' then TempState := FLstNm;
                       if not (aInLn[j] in (['"'] + Lt)) then
                          TempState := WrLstNm;
                   end;
        FLstNm:    begin
                       if aInLn[j] = ',' then TempState := TrdItem;
                       if aInLn[j] = ' ' then TempState := FLstNm;
                       if not (aInLn[j] in [',', ' ']) then
                          TempState := NoSep;
                   end;
        TrdItem:   begin
                       if aInLn[j] in Dg then
                       begin
                           TempState := Dg1;
                           aItem[4] := aItem[4] + aInLn[j];
                       end;
                       if aInLn[j] = ' ' then TempState := TrdItem;
                       if not (aInLn[j] in ([' '] + Dg)) then
                          TempState := WrNatNum;
                   end;
        Dg1:       begin
                       if aInLn[j] in Dg then
                       begin
                           TempState := Dg2;
                           aItem[4] := aItem[4] + aInLn[j];
                       end
                       else TempState := WrNatNum;
                   end;
        Dg2:       begin
                       if aInLn[j] in Dg then
                       begin
                           TempState := Dg3;
                           aItem[4] := aItem[4] + aInLn[j];
                       end
                       else TempState := WrNatNum;
                   end;
        Dg3:       begin
                       if aInLn[j] in Dg then
                       begin
                           TempState := Dg4;
                           aItem[4] := aItem[4] + aInLn[j];
                       end
                       else TempState := WrNatNum;
                   end;
        Dg4:       begin
                       if aInLn[j] in Dg then
                       begin
                           TempState := Dg5;
                           aItem[4] := aItem[4] + aInLn[j];
                       end
                       else TempState := WrNatNum;
                   end;
        Dg5:       begin
                       if aInLn[j] in Dg then
                       begin
                           TempState := Dg6;
                           aItem[4] := aItem[4] + aInLn[j];
                       end
                       else TempState := WrNatNum;
                   end;
        Dg6:       begin
                       if aInLn[j] = '/' then
                       begin
                           TempState := Slash;
                           aItem[4] := aItem[4] + aInLn[j];
                       end
                       else TempState := WrNatNum;
                   end;
        Slash:     begin
                       if aInLn[j] in Dg then
                       begin
                           TempState := Dg7;
                           aItem[4] := aItem[4] + aInLn[j];
                       end
                       else TempState := WrNatNum;
                   end;
        Dg7:       begin
                       if aInLn[j] in Dg then
                       begin
                           TempState := Dg8;
                           aItem[4] := aItem[4] + aInLn[j];
                       end
                       else TempState := WrNatNum;
                   end;
        Dg8:       begin
                       if aInLn[j] in Dg then
                       begin
                           TempState := Dg9;
                           aItem[4] := aItem[4] + aInLn[j];
                       end
                       else TempState := WrNatNum;
                   end;
        Dg9:       begin
                       if aInLn[j] in Dg then
                       begin
                           TempState := Dg10;
                           aItem[4] := aItem[4] + aInLn[j];
                       end;
                       if aInLn[j] = ' ' then TempState := SbFNatNum;
                       if aInLn[j] = ',' then TempState := FthItem;
                       if not (aInLn[j] in ([' ', ','] + Dg)) then
                          TempState := WrNatNum;
                   end;
        Dg10:      begin
                       if aInLn[j] = ' ' then TempState := SbFNatNum;
                       if aInLn[j] = ',' then TempState := FthItem;
                       if not (aInLn[j] in [' ', ',']) then
                          TempState := WrNatNum;
                   end;
        SbFNatNum: begin
                       if aInLn[j] = ' ' then TempState := SbFNatNum;
                       if aInLn[j] = ',' then TempState := FthItem;
                       if not (aInLn[j] in [' ', ',']) then
                          TempState := NoSep;
                   end;
        FthItem:   begin
                       if aInLn[j] = '"' then TempState := SFm;
                       if aInLn[j] = ' ' then TempState := FthItem;
                       if not (aInLn[j] in ['"', ' ']) then
                          TempState := NoQMark;
                   end;
        SFm:       begin
                       if aInLn[j] in PChr then
                       begin
                           TempState := BFm;
                           aItem[5] := aItem[5] + aInLn[j];
                       end;
                       if aInLn[j] = '"' then TempState := SbFFm;
                       if not (aInLn[j] in (['"'] + PChr)) then
                          TempState := WrFmNt;
                   end;
        BFm:       begin
                       if aInLn[j] in PChr then
                       begin
                           TempState := BFm;
                           aItem[5] := aItem[5] + aInLn[j];
                       end;
                       if aInLn[j] = '"' then TempState := SbFFm;
                       if not (aInLn[j] in (['"'] + PChr)) then
                          TempState := WrFmNt;
                   end;
        SbFFm:     begin
                       if aInLn[j] = '"' then
                       begin
                           TempState := BFm;
                           aItem[5] := aItem[5] + aInLn[j];
                       end;
                       if aInLn[j] = ',' then TempState := FfthItem;
                       if aInLn[j] = ' ' then TempState := WSep2;
                       if not (aInLn[j] in ['"', ',', ' ']) then
                          TempState := WrFmNt;
                   end;
        WSep2:     begin
                       if aInLn[j] = ',' then TempState := FfthItem;
                       if aInLn[j] = ' ' then TempState := WSep2;
                       if not (aInLn[j] in [',', ' ']) then
                          TempState := NoSep;
                   end;
        FfthItem:  begin
                       if aInLn[j] = '"' then TempState := SNt;
                       if aInLn[j] = ' ' then TempState := FfthItem;
                       if not (aInLn[j] in ['"', ' ']) then
                          TempState := NoQMark;
                   end;
        SNt:       begin
                       if aInLn[j] in PChr then
                       begin
                           TempState := BNt;
                           aItem[6] := aItem[6] + aInLn[j];
                       end;
                       if aInLn[j] = '"' then TempState := SbFNt;
                       if not (aInLn[j] in (['"'] + PChr)) then
                          TempState := WrFmNt;
                   end;
        BNt:       begin
                       if aInLn[j] in PChr then
                       begin
                           TempState := BNt;
                           aItem[6] := aItem[6] + aInLn[j];
                       end;
                       if aInLn[j] = '"' then TempState := SbFNt;
                       if not (aInLn[j] in (['"'] + PChr)) then
                          TempState := WrFmNt;
                   end;
        SbFNt:     begin
                       if aInLn[j] = '"' then
                       begin
                           TempState := BNt;
                           aItem[6] := aItem[6] + aInLn[j];
                       end
                       else TempState := WrFmNt;
                   end;
      end;
      aState := TempState;
  end;
end;

procedure Launch(var Settings: TSettings);
   {provede konen automat s pedanmi parametry}
var
   CanProtocolize: Boolean;
   i: Integer;
   k: Byte;
   InLn: string;
   State: TState;
   MyItem: TItem;
   InF, Protocol: text;
   OutF: file of TItem;
begin
    if not Settings.MadeSettings then SetSettings(Settings);
    Assign(InF, Settings.InFile);
    Assign(OutF, Settings.OutFile);
    Assign(Protocol, Settings.Protocol);
    {$I-}
    Rewrite(Protocol);
    {$I+}
    if IOResult = 0 then {soubor se podailo otevt}
    begin
        CanProtocolize := True; {je mon protokolovat prbh automatu}
        Close(Protocol);
    end
    else
        CanProtocolize := False;
    {$I-}
    Reset(InF);
    {$I+}
    if IOResult = 0 then {soubor se podailo otevt}
    begin
        {$I-}
        Rewrite(OutF);
        {$I+}
        if IOResult = 0 then {soubor se podailo otevt}
        begin
            if Eof(InF) then WriteLn('Soubor je przdn.');
            while not Eof(InF) do
            begin
                ReadLn(InF, InLn);
                State := Start; {vchoz stav pro kad dek}
                i := 0;
                for k := 1 to PartsCount do
                    MyItem[k] := '';
                while not (State in EndState) do {dokud stav nen konen}
                begin
                    i := succ(i);
                    InterpretChar(InLn, i, State, MyItem); {vyhodnot znak}
                end;
                if State = AllRight then {pokud je ve v podku}
                begin
                   Write(OutF, MyItem);  {zape se zznam do vstupu}
                end;
                WriteLn(WriteState(State)); {vpis hlen na obrazovku}
                if CanProtocolize then
                begin
                    Append(Protocol);
                    WriteLn(Protocol, WriteState(State));
                       {pidn hlen do protokolu}
                    Close(Protocol);
                end;
            end;
            Close(OutF);
        end
        else
            WriteLn('Clov soubor se nepodailo otevt.');
        Close(InF);
    end
    else
        WriteLn('Zdrojov soubor se nepodailo otevt.');
end;

end.