{      Autor: Jakub Novk 1F-51   login xnovak53

Jednotka pro prci se sloupcovm menu.}

Unit Proj_3ua; {MyMenu}

interface

const
     mmMaxMenus = 5; {maximln poet nabdek}
     mmEnter = #13;
     mmArrowUp = #72;
     mmArrowDown = #80;
     mmF10 = #68;
     mmNothingSelected = 255;
     MenuFileNotFound = 1;
     TooMuchMenus = 2;
type
    TWinName = (MenuWin, UserWin, DfltWin);
    PMyItem = ^TMyItem;
    TMyItem = record
       Caption: string;
       NextItem: PMyItem;
    end;
    PMyMenu = ^TMyMenu;
    TMyMenu = record
       MenuName: string;
       ItemsCount: Byte;
       FirstItem: PMyItem;
       SelItem: Byte;
    end;
    TMyMenus = array[1..mmMaxMenus] of PMyMenu;

procedure Activate(aWinName: TWinName);
   {podle pedefinovanch konstant aktivuje (vykresl) pslun okno}
procedure DrawMyMenu(var aMyMenu: TMyMenu; aSelItem: Byte);
   {vype poloky menu a zvrazn vybran dek}
procedure ReadMenus(MenuFile: string; var aMenus: TMyMenus; var aError: Byte);
   {nate ze souboru poloky jednotlivch nabdek a vytvo z nich linern
   seznam}
procedure DisposeMenus(aMenus: TMyMenus);
   {uvolnn seznamu s nabdkami menu z pamti}
procedure StatusBar(aStr: string); {vykresl stavov dek s hlenm}
function GetItemCaption(aProcMenu: TMyMenu): string;
   {zjist titulek vybranho pkazu - poloky menu}
procedure WriteCenter(aStr: string);
   {vype pedan etzec doprosted aktuln obrazovky, pokud se tam vejde}
procedure HideCursor;
   {skryje kurzor}
procedure ShowCursor;
   {zobraz kurzor}

implementation

uses Crt;

procedure WriteCenter(aStr: string);
   {vype pedan etzec doprosted aktuln obrazovky, pokud se tam vejde}
var
   WinWidth, aX: Byte;
begin
    WinWidth := Lo(WindMax) - Lo(WindMin);
    if Length(aStr) < WinWidth then
    begin
        aX := ((WinWidth - Length(aStr)) div 2) + 1;
        GotoXY(aX, WhereY);
        WriteLn(aStr);
        GotoXY(1, WhereY);
    end;
end;

procedure StatusBar(aStr: string); {vykresl stavov dek s hlenm}
var
   OrigAttr: Word;
begin
    OrigAttr := TextAttr;
    Window(1, 25, 80, 25);
    TextBackground(LightGray);
    TextColor(Black);
    Write(aStr);
    ClrEol;
    TextAttr := OrigAttr;
end;

procedure Activate(aWinName: TWinName);
   {podle pedefinovanch konstant aktivuje (vykresl) pslun okno}
var
   i: Byte;
begin
    case aWinName of
      MenuWin:
         begin
           Window(1, 3, 20, 25);
           TextBackground(Black);
           ClrScr;
           TextColor(DarkGray);
           Write('');
           for i := 2 to 19 do
               Write('');
           Write('');
           for i := 2 to 21 do
           begin
               Write('');
               GotoXY(20, i);
               Write('');
           end;
           Write('');
           for i := 2 to 19 do
               Write('');
           Write('');
           StatusBar(' Pouijte ipky pro pohyb v menu, '
               + 'klvesu Enter pro vbr nabdky.');
           Window(3, 4, 18, 23);
           TextColor(Yellow);
         end;
      UserWin:
         begin
           Window(21, 3, 80, 25);
           TextBackground(Blue);
           ClrScr;
           TextColor(LightCyan);
           Write('');
           for i := 2 to 59 do
               Write('');
           Write('');
           for i := 2 to 21 do
           begin
               Write('');
               GotoXY(60, i);
               Write('');
           end;
           Write('');
           for i := 2 to 59 do
               Write('');
           Write('');
           StatusBar('');
           Window(24, 5, 77, 22);
           TextColor(White);
         end;
      DfltWin:
         begin
             Window(1, 1, 80, 25);
             TextBackground(Black);
             TextColor(White);
             ClrScr;
         end;
    end;
end;

procedure SelectRow(aCaption: string; RowNum: Byte);
   {zvrazn pslun dek v menu}
begin
    TextBackground(LightGreen);
    TextColor(Yellow);
    GotoXY(1, RowNum);
    Write(aCaption);
    ClrEol;
end;

procedure DrawMyMenu(var aMyMenu: TMyMenu; aSelItem: Byte);
   {vype poloky menu a zvrazn vybran dek}
var
   i: Byte;
   TempStr: string;
   TempItem: PMyItem;
begin
    if aSelItem <> mmNothingSelected then
    begin
        aMyMenu.SelItem := aSelItem;
        if aMyMenu.SelItem = 0 then
           aMyMenu.SelItem := aMyMenu.ItemsCount;
        if aMyMenu.SelItem > aMyMenu.ItemsCount then
           aMyMenu.SelItem := 1;
        {pedchoz dv podmnky zajiuj cyklick prochzen nabdek,
        tj. pesunut kurzoru v menu zezdola nahoru a naopak}
    end;
    Activate(MenuWin);
    TempItem := aMyMenu.FirstItem;
    for i := 1 to aMyMenu.ItemsCount do
    begin
        if i = aMyMenu.SelItem then TempStr := TempItem^.Caption;
        WriteLn(TempItem^.Caption);
        TempItem := TempItem^.NextItem;
    end;
    if aSelItem <> mmNothingSelected then
       SelectRow(TempStr, aMyMenu.SelItem);
end;

procedure ReadMenus(MenuFile: string; var aMenus: TMyMenus; var aError: Byte);
   {nate ze souboru poloky jednotlivch nabdek a vytvo z nich linern
   seznam}
var
   i, j: Byte;
   TempStr: string;
   TempItem1, TempItem2: PMyItem;
   F: text;
begin
    Assign(F, MenuFile);
    {$I-}
    Reset(F);
    {$I+}
    if IOResult = 0 then
    begin
         i := 1;
         ReadLn(F, TempStr);
         while not eof(F) and (i <= mmMaxMenus) do
         begin
             New(aMenus[i]);
             aMenus[i]^.MenuName := TempStr;
             ReadLn(F, TempStr);
             New(TempItem1);
             TempItem1^.Caption := TempStr;
             TempItem1^.NextItem := nil;
             aMenus[i]^.FirstItem := TempItem1;
             j := 1;
             ReadLn(F, TempStr);
             while Pos('[', TempStr) = 0 do
             begin
                 New(TempItem2);
                 TempItem2^.Caption := TempStr;
                 TempItem2^.NextItem := nil;
                 TempItem1^.NextItem := TempItem2;
                 TempItem1 := TempItem2;
                 j := j + 1;
                 if eof(F) then
                    TempStr := '['
                 else
                    ReadLn(F, TempStr);
             end;
             aMenus[i]^.ItemsCount := j;
             aMenus[i]^.SelItem := 1;
             i := i + 1;
         end;
         if (i > mmMaxMenus) and not eof(F) then
               {poet nabdek menu peshl maximln definovanou hodnotu}
            aError := TooMuchMenus;
         Close(F);
    end
    else
        aError := MenuFileNotFound; {soubor s polokami menu nebyl nalezen}
end;

procedure DisposeMenus(aMenus: TMyMenus);
   {uvolnn seznamu s nabdkami menu z pamti}
var
   i: Byte;
   TempItem: PMyItem;
begin
    for i := 1 to mmMaxMenus do
    begin
        if aMenus[i] <> nil then
        begin
            while aMenus[i]^.FirstItem^.NextItem <> nil do
            begin
                TempItem := aMenus[i]^.FirstItem;
                aMenus[i]^.FirstItem := TempItem^.NextItem;
                Dispose(TempItem);
            end;
            Dispose(aMenus[i]^.FirstItem);
            Dispose(aMenus[i]);
        end;
    end;
end;

function GetItemCaption(aProcMenu: TMyMenu): string;
   {zjist titulek vybranho pkazu - poloky menu}
var
   i: Byte;
   TempItem: PMyItem;
begin
    TempItem := aProcMenu.FirstItem;
    for i := 1 to aProcMenu.SelItem - 1 do
        TempItem := TempItem^.NextItem;
    GetItemCaption := TempItem^.Caption;
end;

procedure HideCursor;
begin
  asm
    mov ah,1
    mov ch,20h
    int 10h
  end;
end;

procedure ShowCursor;
begin
  asm
    mov ah,1
    mov ch,8
    mov cl,9
    int 10h
  end;
end;

end.