{Projekt 4      Autor: Jakub Novk 1F-51   login xnovak53

programov jednotka pro simulaci prce se soubory na principu linernch
seznam}

unit Proj_4u;

interface

type
    TState = (Closed, OpenedForRead, OpenedForWrite); {stav souboru}
    PData = ^TData;
    TData = record
                DData: string;
                DNext: PData; {ukazuje na dalsi polozku}
            end;

    PFile = ^TFile;
    TFile = record
                FName: string;  {nazev souboru}
                FSize: longint; {velikost souboru}
                FEof: boolean;  {identifikace konce souboru}
                FPos: longint;  {ukazatel pozice v souboru}
                FState: TState; {otevreny pro zapis/cteni,zavreny}
                FData: PData;   {ukazatel na prvn poloku seznamu dat}
                FNext: PFile;   {ukazuje na dalsi soubor}
            end;

var
   FirstFile: PFile; {prvn soubor v seznamu}

procedure MyRewrite(Jmeno: string); {prida nebo prepise existujici soubor}
procedure MyReset(Jmeno: string); {otevre existujici soubor pro cteni}
procedure MyClose(Jmeno: string); {zavre soubor}
procedure MyErase(Jmeno: string); {vymae soubor ze seznamu, uvoln z pamti}
procedure MySeek(Jmeno: string; l: longint); {nastavi ukazatel na pozici l}
procedure MyTruncate(Jmeno: string);{zkrati soubor na hodnotu FilePos}
procedure MyRead(Jmeno: string; var aStr: string); {pete aStr z FilePos}
procedure MyWrite(Jmeno: string; aStr: string); {zape aStr na FilePos}
function MyFilePos(Jmeno: string): longint; {vrati ukazetel v souboru}
function MyEof(Jmeno: string): boolean; {vrati stav konce souboru}
function MyFileSize(Jmeno: string): longint; {vrt velikost souboru}
function FCount: byte; {vrt poet soubor v seznamu}

implementation

type
    TError = (NoError, FNameNotFound, FNameNotOpened, FNameNotReadOpened,
              FNameNotWriteOpened, FNameSmaller, FNameFEof);
              {mon chyby pi vkonu programu}

procedure ErrorMessage(aError: TError); {vype chybov hlen}
begin
    case aError of
        FNameNotFound:  WriteLn('Soubor nebyl nalezen.');
        FNameSmaller:   WriteLn('Soubor je men ne dan pozice.');
        FNameFEof:      WriteLn('Ukazatel je ji na konci souboru.');
        FNameNotOpened: WriteLn('Soubor nen oteven.');
        FNameNotReadOpened:  WriteLn('Soubor nen oteven pro ten.');
        FNameNotWriteOpened: WriteLn('Soubor nen oteven pro zpis.');
    end;
end;

procedure ListFiles(var aJmeno: string; var aFile: PFile; var aError: TError);
   {prolistuje seznam a vrt ukazatel, kter ukazuje na hledan soubor}
var
   Found: Boolean;
   TempFile: PFile;
begin
    aError := NoError;
    Found := False;
    TempFile := FirstFile;
    while (TempFile <> nil) and not Found do
    begin
        if TempFile^.FName = aJmeno then
        begin
            Found := True;
            aFile := TempFile;
        end;
        if TempFile^.FNext <> nil then TempFile := TempFile^.FNext
        else TempFile := nil;
    end;
    if not Found then aError := FNameNotFound;
end;

procedure MyRewrite(Jmeno: string); {prida nebo prepise existujici soubor}
var
   Error: TError;
   MyFile: PFile;
   TempFile1, TempFile2: PFile;
   TempData: PData;
begin
    ListFiles(Jmeno, MyFile, Error);
    if Error = NoError then {soubor ji v seznamu existuje}
    begin
        with MyFile^ do
        begin
            while FData <> nil do
            begin
                TempData := FData^.DNext;
                if TempData <> nil then
                begin
                    FData^.DNext := TempData^.DNext;
                    Dispose(TempData);
                end
                else
                begin
                    Dispose(FData);
                    FData := nil;
                end;
            end;
            FSize := 0;
            FPos := 0;
            FEof := True;
            FState := OpenedForWrite;
        end;
    end
    else {jinak vytvo nov soubor}
    begin
        TempFile1 := FirstFile;
        New(TempFile2);
        with TempFile2^ do
        begin
            FName := Jmeno;
            FSize := 0;
            FPos := 0;
            FEof := True;
            FState := OpenedForWrite;
            FData := nil;
            FNext := nil;
        end;
        if TempFile1 = nil then   {v seznamu nen jet dn soubor}
           FirstFile := TempFile2 {vytvo prvn soubor}
        else
        begin
            while TempFile1^.FNext <> nil do TempFile1 := TempFile1^.FNext;
                                           {najde posledn soubor}
            TempFile1^.FNext := TempFile2; {pid soubor na konec seznamu}
        end;
    end;
end;

procedure MyReset(Jmeno: string); {otevre existujici soubor pro cteni}
var
   Error: TError;
   MyFile: PFile;
   TempData: PData;
begin
    ListFiles(Jmeno, MyFile, Error);
    if Error = NoError then
    begin
        with MyFile^ do
        begin
            FPos := 0;
            if FPos = FSize then FEof := True else FEof := False;
            FState := OpenedForRead;
        end;
    end
    else
        ErrorMessage(Error);
end;

procedure MyClose(Jmeno: string); {zavre soubor}
var
   Error: TError;
   MyFile: PFile;
begin
    ListFiles(Jmeno, MyFile, Error);
    if Error = NoError then
    begin
        with MyFile^ do
        begin
            if FState <> Closed then
                FState := Closed
            else
                ErrorMessage(FNameNotOpened);
        end;
    end
    else
        ErrorMessage(Error);
end;

procedure MyErase(Jmeno: string); {vymae soubor ze seznamu, uvoln z pamti}
var
   Error: TError;
   MyFile: PFile;
   TempData: PData;
   TempFile, TempFile2: PFile;
begin
    ListFiles(Jmeno, MyFile, Error);
    if Error = NoError then
    begin
        with MyFile^ do
        begin
            while FData <> nil do {uvoln obsah souboru z pamti}
            begin
                TempData := FData^.DNext;
                if TempData <> nil then
                begin
                    FData^.DNext := TempData^.DNext;
                    Dispose(TempData);
                end
                else
                begin
                    Dispose(FData);
                    FData := nil;
                end;
            end;
        end;
        TempFile := FirstFile;
        if MyFile^.FName = TempFile^.FName then {mae se prvn soubor}
        begin
            FirstFile := TempFile^.FNext;
            Dispose(TempFile);
        end
        else {jinak najde soubor, kter se m smazat, a smae ho}
        begin
            while TempFile^.FNext^.FName <> MyFile^.FName do
                  TempFile := TempFile^.FNext;
            TempFile2 := TempFile^.FNext;
            TempFile^.FNext := TempFile2^.FNext;
            Dispose(TempFile2);
        end;
    end
    else
        ErrorMessage(Error);
end;

procedure MySeek(Jmeno: string; l: longint); {nastavi ukazatel na pozici l}
var
   i: longint;
   Error: TError;
   MyFile: PFile;
begin
    ListFiles(Jmeno, MyFile, Error);
    if Error = NoError then
    begin
        with MyFile^ do
        begin
            if FState <> Closed then
            begin
                if l <= FSize then
                   {nedovol nastaven ukazatele za konec souboru}
                begin
                    FPos := l;
                    if FPos = FSize then FEof := True else FEof := False;
                end
                else
                    ErrorMessage(FNameSmaller);
            end
            else
                ErrorMessage(FNameNotOpened);
        end;
    end
    else
        ErrorMessage(Error);
end;

procedure MyTruncate(Jmeno: string); {zkrati soubor na hodnotu FilePos}
var
   i: longint;
   Error: TError;
   MyFile: PFile;
   TempData, TempData2: PData;
begin
    ListFiles(Jmeno, MyFile, Error);
    if Error = NoError then
    begin
        with MyFile^ do
        begin
            if FState <> Closed then
            begin
                if not FEof then
                begin
                    TempData := FData;
                    for i := 0 to FPos - 2 do
                       {najde prvek ped mstem, od kterho se bude oezvat}
                        TempData := TempData^.DNext;
                    while TempData^.DNext <> nil do
                     {uvoln z pamti tu st souboru, kter se m odznout}
                    begin
                        TempData2 := TempData^.DNext;
                        TempData^.DNext := TempData2^.DNext;
                        Dispose(TempData2);
                    end;
                    if FPos = 0 then
                    begin
                        Dispose(TempData);
                        FData := nil;
                    end;
                    FSize := FPos;
                    FEof := True;
                end
                else
                    ErrorMessage(FNameFEof);
            end
            else
                ErrorMessage(FNameNotOpened);
        end;
    end
    else
        ErrorMessage(Error);
end;

procedure MyRead(Jmeno: string; var aStr: string); {pete aStr z FilePos}
var
   i: longint;
   Error: TError;
   MyFile: PFile;
   TempData: PData;
begin
    ListFiles(Jmeno, MyFile, Error);
    if Error = NoError then
    begin
        with MyFile^ do
        begin
            if FState = OpenedForRead then
            begin
                if not FEof then
                begin
                    TempData := FData;
                    for i := 0 to FPos - 1 do
                        {najde pozici, ze kter se m st}
                        TempData := TempData^.DNext;
                    aStr := TempData^.DData;
                    FPos := Succ(FPos);
                    if FPos = FSize then FEof := True;
                end
                else
                    ErrorMessage(FNameFEof);
            end
            else
                ErrorMessage(FNameNotReadOpened);
        end;
    end
    else
        ErrorMessage(Error);
end;

procedure MyWrite(Jmeno: string; aStr: string); {zape aStr na FilePos}
var
   i: longint;
   Error: TError;
   MyFile: PFile;
   TempData, TempData2: PData;
begin
    ListFiles(Jmeno, MyFile, Error);
    if Error = NoError then
    begin
        with MyFile^ do
        begin
            if FState = OpenedForWrite then
            begin
                New(TempData2);
                TempData2^.DData := aStr;
                if FData <> nil then {v souboru je alespo jeden zznam}
                begin
                    TempData := FData;
                    for i := 0 to FPos - 2 do
                        {najde prvek ped pozic, na kterou se m zapisovat}
                        TempData := TempData^.DNext;
                    if FPos = 0 then
                    begin
                        TempData2^.DNext := FData;
                        FData := TempData2;
                    end
                    else
                    begin
                        if FEof then TempData2^.DNext := nil
                        else TempData2^.DNext := TempData^.DNext;
                        TempData^.DNext := TempData2;
                    end;
                end
                else
                begin
                    TempData2^.DNext := nil;
                    FData := TempData2;
                end;
                FPos := Succ(FPos);
                FSize := Succ(FSize);
            end
            else
                ErrorMessage(FNameNotWriteOpened);
        end;
    end
    else
        ErrorMessage(Error);
end;

function MyFilePos(Jmeno: string): longint; {vrati ukazetel v souboru}
var
   Error: TError;
   MyFile: PFile;
begin
    ListFiles(Jmeno, MyFile, Error);
    if Error = NoError then
    begin
        with MyFile^ do
        begin
            if FState <> Closed then
                MyFilePos := FPos
            else
                ErrorMessage(FNameNotOpened);
        end;
    end
    else
        ErrorMessage(Error);
end;

function MyEof(Jmeno: string): boolean; {vrati stav konce souboru}
var
   Error: TError;
   MyFile: PFile;
begin
    ListFiles(Jmeno, MyFile, Error);
    if Error = NoError then
    begin
        with MyFile^ do
        begin
            if FState <> Closed then
                MyEof := FEof
            else
                ErrorMessage(FNameNotOpened);
        end;
    end
    else
        ErrorMessage(Error);
end;

function MyFileSize(Jmeno: string): longint; {vrt velikost souboru}
var
   Error: TError;
   MyFile: PFile;
begin
    ListFiles(Jmeno, MyFile, Error);
    if Error = NoError then
    begin
        with MyFile^ do
        begin
            if FState <> Closed then
                MyFileSize := FSize
            else
                ErrorMessage(FNameNotOpened);
        end;
    end
    else
        ErrorMessage(Error);
end;

function FCount: byte; {vrt poet soubor v seznamu}
var
   Counter: Byte;
   TempFile: PFile;
begin
    Counter := 0;
    TempFile := FirstFile;
    while TempFile <> nil do
    begin
        Counter := Succ(Counter);
        TempFile := TempFile^.FNext;
    end;
    FCount := Counter;
end;

begin
    FirstFile := nil; {iniciace exportovan promnn}
end.